// Example of Splash, Login and Sign Up in React Native
// https://aboutreact.com/react-native-login-and-signup/

// Import React and Component
import React, { useState, useEffect } from "react";
import {
  StyleSheet,
  View,
  Text,
  SafeAreaView,
  TouchableOpacity,
  TextInput,
  ImageBackground,
} from "react-native";
import { Formik } from "formik";
import { FontAwesome } from "@expo/vector-icons";
import { MaterialCommunityIcons } from "@expo/vector-icons";
import { BottomTab } from "../Navigations/BottomTab";
import { Entypo } from "@expo/vector-icons";
import axios from "axios";

export function gamification({ navigation }) {
  // const [title, setTitle] = useState();
  const [earn, setEarn] = useState("");

  const fetchData = async () => {
    // const resp = await fetch("http://192.168.8.126:5000/getDetails", {method:"POST"});

    axios({
      method: "GET",
      url: "http://192.168.8.126:5000/getVal/<id>",
    })
      .then(function (response) {
          console.log(response.data.message);
        // data = response.data
        setEarn(response.data.message);
      })
      .catch(function (error) {
        console.log("axios error" + error);
      });
  };

  useEffect(() => {
    fetchData();
  },[]);
  // const handlecarrot = () => {
  //   setTitle({title: "carrot"});
  //   console.log(title)
  //   return title
  // };

  return (
    <SafeAreaView style={{ flex: 1, color: "yellow" }}>
      <ImageBackground
        source={require("../assets/gamification.jpg")}
        style={styles.images}
      >
        <Formik
          initialValues={{ name: "", title: "" }}
          onSubmit={(values, actions) => {
            console.log(values);

            // console.log(title)

            // console.log(title);
            // console.log(values.name);
            // console.log(values.title);

            const form = new FormData();

            form.append("name", values.name);
            form.append("title", values.title);

            // console.log(form)
            axios({
              method: "POST",
              url: "http://192.168.8.126:5000/points/<id>",
              data: form,
              // headers: {
              //   "Content-Type": "multipart/form-data",
              // },
            })
              .then(function (response) {
                console.log("abc" + response);
                actions.resetForm();
                // return response;
              })
              .catch(function (error) {
                console.log(error);
              });
          }}
        >
          {(props) => (
            <View style={styles.container}>
              <View
                style={{
                  alignSelf: "center",
                  marginTop: 10,
                }}
              >
                <MaterialCommunityIcons
                  name="map-marker-distance"
                  size={50}
                  color="black"
                />
              </View>
              <View style={styles.iconView}>
                <Text style={styles.heading}> Earn value calculation </Text>

                <View style={styles.containerinside}>
                  <View style={styles.iconViewinside}>
                    <Entypo name="location" size={24} color="white" />
                    <TextInput
                      style={styles.input}
                      placeholder="Area in square meter"
                      onChangeText={props.handleChange("name")}
                      value={props.values.name}
                    />
                  </View>
                </View>

                <TouchableOpacity
                  style={styles.buttonSub}
                  title="apple"
                  onPress={(title) => {
                    props.setFieldValue("title", "apple");
                    props.handleSubmit(title);
                  }}
                  // onPress={handlecarrot}
                >
                  <Text style={styles.buttonText}>Brinjal</Text>
                </TouchableOpacity>

                <TouchableOpacity
                  style={styles.buttonSub}
                  title="tomato"
                  onPress={(title) => {
                    props.setFieldValue("title", "tomato");
                    props.handleSubmit(title);
                  }}
                >
                  <Text style={styles.buttonText}>Tomato</Text>
                </TouchableOpacity>

                <TouchableOpacity
                  style={styles.buttonSub}
                  title="chilli"
                  onPress={(title) => {
                    props.setFieldValue("title", "chilli");
                    props.handleSubmit(title);
                  }}
                >
                  <Text style={styles.buttonText}>chilli</Text>
                </TouchableOpacity>

                <TouchableOpacity
                  style={styles.buttonSub}
                  title="pepper"
                  onPress={(title) => {
                    props.setFieldValue("title", "pepper");
                    props.handleSubmit(title);
                  }}
                >
                  <Text style={styles.buttonText}>Pepper</Text>
                </TouchableOpacity>
              </View>

                <View
                  style={{
                    alignSelf: "center",
                    marginTop: 10,
                  }}
                >
                  <FontAwesome name="money" size={50} color="black"  style={{
                    alignSelf: "center",
                  }}/>
                  <Text style={styles.textdata}>TOTAL EARNED $: {earn}</Text>
                 
                </View>
              
            </View>
          )}
        </Formik>
        <BottomTab />
      </ImageBackground>
    </SafeAreaView>
  );
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    color: "#333",
    padding: 10,
    marginTop: 20,
    marginBottom: 10,
    width: "100%",
    // flexDirection: "column",
    alignContent: "center",
    alignSelf: "center",
  },
  activityIndicator: {
    alignItems: "center",
    height: 80,
  },
  Button: {
    alignItems: "center",
    backgroundColor: "#DDDDDD",
    padding: 10,
  },
  input: {
    borderWidth: 1,
    borderColor: "#ddd",
    padding: 10,
    paddingTop: 10,
    fontSize: 18,
    borderRadius: 6,
    marginTop: 20,
    marginBottom: 10,
    marginLeft: 10,
    marginRight: 10,
    borderRadius: 25,
    backgroundColor: "white",
    width: "75%",
    height: 40,
  },
  heading: {
    textAlign: "center",
    color: "#333",
    fontWeight: "bold",
    padding: 10,
    fontSize: 18,
  },
  buttonSub: {
    width: "85%",
    padding: 10,
    marginTop: 20,
    marginLeft: 20,
    marginHorizontal: 10,
    backgroundColor: "#ff8000",
    flexDirection: "row",
    marginBottom: 10,
    justifyContent: "center",
    borderRadius: 10,
  },
  textdata: {
    fontSize: 18,
    textAlign: "center",
    color: "black",
    marginTop: 20,
    marginBottom: 5,
  },
  iconView: {
    // alignSelf: "center",
    // flexDirection: "column",
    // justifyContent:"center"
  },
  images: {
    height: "100%",
    justifyContent: "center",
  },
  containerinside: {
    color: "#333",
    width: "100%",
  },
  iconViewinside: {
    // flexDirection: "row",
    // justifyContent: "center",
    // alignItems: "center",
    color: "yellow",
    flexDirection: "row",
    alignItems: "center",
    alignSelf: "center",
  },
});
